Kompatybilność aplikacji wersji 2.3 do 4.4 - android

Odpowiedz Nowy wątek
2015-01-10 11:21
0

Witam,

Zrobiłem sobie w eclipse aplikację gdzie wersja minimalna to 2.3.3 a target i docelowa 4.4 androida i mam problem bo np. w edittext i w buttonach poustawiałem kolory tła i text-u i w wersji 2.3.3 wygląda ok, ale jak zainstaluję aplikację na 4.4 to białe tło edittext-a robi się czarne i nie widać czarnego tekstu w 4.4 napisy na buttonach mam białe w 2.3 a w 4.4 są tak szare że prawie nie odróżniają się od koloru buttonu. Dlaczego tak jest ?
Jak ustawiać formularze, żeby w miarę w każdej wersji wyglądało to tak samo ?

Nie ma sensu ustawiać wersji minimalnej poniżej 4.0.3... - SmallCutePenguin 2015-01-10 12:06

Pozostało 580 znaków

2015-01-10 12:34
1

Żeby zachowywać kompatybilność wsteczną należy używać biblioteki appcompat. Pewnie jej nie użyłeś, zastosowałeś nowszy szablon (theme) i stąd ten błąd.
Możesz też spróbować ustawić customowe style dla editTextu w pliku styles.xml, żeby wszędzie wyglądał on identycznie bez względu na wersję systemu.
Ogólnie, radzę Ci ustawiać minSdk na minimum 4.0 lub 4.0.3 jak napisał @SmallCutePenguin.

Zasadniczo, użytkownicy starszych wersji Androida stanowią znikomy procent rynku.
Przykładowo, parę miesięcy temu wrzuciłem na Google Play aplikację targetowaną na Android API 2.1 i wzwyż, po czym okazało się, że użytkownicy aplikacji, którzy posiadają Androida starszego, niż wersja 4 stanowią ok. 3.5% wszystkich użytkowników aplikacji. Jeżeli wezmę pod uwagę wszystkich użytkowników, którzy kiedykolwiek ściągnęli aplikację, to współczynnik osób z Androidem poniżej wersji 4 wyniósł ok. 10%. Miałem do dyspozycji dane ponad 1700 użytkowników. Myślę, że w przypadku innych aplikacji jest podobnie i 90% użytkowników ma wersję 4 i wzwyż. Teraz zaczyna się zabawa z kompatybilnością wsteczną w KitKacie, gdy piszemy na Lollipopa, a wolę nie myśleć, ile byłoby walki, żeby to poszło na jeszcze starszych systemach. Android po prostu sukcesywnie wypiera stare wersje systemu, a IMO pierwsza "używalna" wersja Androida, to właśnie 4 (KitKat).

edytowany 3x, ostatnio: wiciu, 2015-01-10 12:46

Pozostało 580 znaków

2015-01-10 12:44
0

Ja strzelam, że niektóre kolory ustawiłeś na systemowe (np systemowy kolor dla tekstu), a niektóre na sztywno (np biały) i stąd są problemy. Możesz ustawić wszystko na kolory systemowe albo wszystko na sztywno. Ale to tylko domniemywanie, w Androidzie nie zrobiłem żadnej apki.


"Programs must be written for people to read, and only incidentally for machines to execute." - Abelson & Sussman, SICP, preface to the first edition
"Ci, co najbardziej pragną planować życie społeczne, gdyby im na to pozwolić, staliby się w najwyższym stopniu niebezpieczni i nietolerancyjni wobec planów życiowych innych ludzi. Często, tchnącego dobrocią i oddanego jakiejś sprawie idealistę, dzieli od fanatyka tylko mały krok."
Demokracja jest fajna, dopóki wygrywa twoja ulubiona partia.

Pozostało 580 znaków

Odpowiedz
Liczba odpowiedzi na stronę

1 użytkowników online, w tym zalogowanych: 0, gości: 1, botów: 0